/**
 * Copyright (c) 2014-2016 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see http://www.gnu.org/licenses/
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.registry_overlay.junit;

import static org.junit.Assert.assertEquals;

import org.junit.Rule;
import org.junit.Test;
import org.ow2.petals.registry_overlay.api.Constants;

import com.hazelcast.client.HazelcastClient;
import com.hazelcast.client.config.ClientConfig;
import com.hazelcast.client.config.ClientNetworkConfig;
import com.hazelcast.config.GroupConfig;
import com.hazelcast.core.HazelcastInstance;

/**
 * Unit tests of the JUnit external resource {@link PetalsRegistryOverlayNode}.
 * 
 * @author Christophe DENEUX - Linagora
 * 
 */
public class PetalsRegistryOverlayNodeTest {

    @Rule
    public PetalsRegistryOverlayNode petalsRegistryNode = new PetalsRegistryOverlayNode();

    @Test
    public void defaultConfiguration() {
        
        assertEquals("localhost", this.petalsRegistryNode.getHost());
        assertEquals(Constants.DEFAULT_PORT, this.petalsRegistryNode.getPort());
        assertEquals(Constants.DEFAULT_CREDENTIALS_GROUP, this.petalsRegistryNode.getGroupName());
        assertEquals(Constants.DEFAULT_CREDENTIALS_PASSWORD, this.petalsRegistryNode.getPassword());

        // Try to connect using an Hazelcast client
        final ClientConfig clientConfig = new ClientConfig();
        final GroupConfig groupConfig = new GroupConfig();
        groupConfig.setName(Constants.DEFAULT_CREDENTIALS_GROUP);
        groupConfig.setPassword(Constants.DEFAULT_CREDENTIALS_PASSWORD);
        clientConfig.setGroupConfig(groupConfig);
        final ClientNetworkConfig networkConfig = new ClientNetworkConfig();
        networkConfig.addAddress(this.petalsRegistryNode.getHost() + ":"
                + String.valueOf(this.petalsRegistryNode.getPort()));
        clientConfig.setNetworkConfig(networkConfig);
        
        final HazelcastInstance hzlClient = HazelcastClient.newHazelcastClient(clientConfig);
        hzlClient.shutdown();
    }

}
